'
' Copyright (c) 2016, MindFusion LLC - Bulgaria.
'

Imports System
Imports System.Drawing
Imports System.Drawing.Drawing2D


Partial Public Class CustomDrawnReport
    Inherits Report

    Public Sub New()

        InitializeComponent()

        Sales_by_CategoryTableAdapter1.Fill(NwindDataSet1.Sales_by_Category)
        CategoriesTableAdapter1.Fill(NwindDataSet1.Categories)

    End Sub

    Private Sub canvas_RenderContents(ByVal sender As System.Object, ByVal e As MindFusion.Reporting.DrawCanvasEventArgs) Handles canvas1.RenderContents

        ' Calculate the sum of all sales
        If sumSales Is Nothing Then
            sumSales = SumSalesTableAdapter1.ScalarQuery()
        End If

        If sumSales IsNot Nothing Then
            ' Calculate the current sale amount as a percent of the total sales
            Dim percent As Double = CDbl(CDec(e.DataValue)) / CDbl(sumSales.Value) * 100

            Dim bounds As RectangleF = e.Bounds
            bounds.Inflate(-1, -1)

            ' Draw a semi-filled rectangle illustrating the sale percantage
            Dim fill As Double = bounds.Width * percent / 100
            Using fillBrush = New SolidBrush(Color.FromArgb(&HFF, &H80, &H0))
                e.Graphics.FillRectangle(fillBrush, bounds.X, bounds.Y, CSng(fill), bounds.Height)
            End Using

            Dim format As New StringFormat()
            format.Alignment = StringAlignment.Far
            format.LineAlignment = StringAlignment.Center
            Dim text As String = String.Format("{0:0.##} %", percent)
            Using font = New Font(FontName, FontSize, FontStyle)
                e.Graphics.DrawString(text, font, Brushes.Black, bounds, format)
            End Using
            format.Dispose()
        Else
        End If

        Using borderPen = New Pen(Color.FromArgb(&HD2, &HD7, &HE3), 0)
            e.Graphics.DrawRectangle(borderPen, e.Bounds)
        End Using

    End Sub


    Private sumSales As Nullable(Of Decimal)

End Class
